(* Time-stamp: <modified the 17/06/2021 (at 11:09) by Erwan Jahier> *)

type t = {
  mutable topo: string;
  mutable length: int;
  mutable verbose: int;
  mutable daemon: DaemonType.t;
  mutable rif: bool;
  mutable no_data_file: bool;
  mutable quiet: bool;
  mutable ifi: bool;
  mutable gen_lutin: bool;
  mutable gen_oracle: bool;
  mutable dummy_input: bool;
  mutable output_algos: bool;
  mutable gen_register: bool;
  
  mutable _args : (string * Arg.spec * string) list;
  mutable _user_man  : (string * string list) list; 
  mutable _hidden_man: (string * string list) list; 

  mutable _others : string list;
  mutable _margin : int;
}

val usage_msg : string -> string

val parse : string array -> t
